/*
 * cbp.h
 *
 *  Created on: Oct 15, 2015
 *    Author: Ali Rostami (WINLAB, Rutgers University)
 *		Email: rostami@winlab.rutgers.edu
 *		Homepage: alirostami.info
 */

#ifndef CBP_H_
#define CBP_H_

#include "ns3/core-module.h"
#include "ns3/simulator.h"
#include "ns3/ptr.h"
#include "ns3/node.h"
#include "ns3/wifi-module.h"
#include "ns3/application.h"
#include "ns3/multi-app.h"
#include "ns3/event-id.h"
#include "ns3/log.h"

namespace ns3
{

class CBP
{
public:
	double smoothed_CBP_;
	double raw_CBP_;
	double cbp_calculation_window_;
	double idle_duration_;
	double idle_ratio_;
	double cbp_smooth_factor_;
	Time start_time_;
	bool first_CBP_calculation_;
	EventId next_calculation_;
	Ptr<Node>	node_;
	Ptr<YansWifiPhy> phy_;

	CBP();
	void ScheduleCalculation();
	void CalculateCBP();
	void CBPStart();

	inline double GetSmoothedCBP() { return smoothed_CBP_; }
	inline double GetRawCBP() { return raw_CBP_; }
	inline void SetNode(Ptr<Node> node) { node_ =  node; }
};

}

#endif /* CBP_H_ */
